# coding: utf-8
# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210215


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class UpdateContainerScanRecipeDetails(object):
    """
    The information to update an existing container scan recipe
    """

    def __init__(self, **kwargs):
        """
        Initializes a new UpdateContainerScanRecipeDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param display_name:
            The value to assign to the display_name property of this UpdateContainerScanRecipeDetails.
        :type display_name: str

        :param image_count:
            The value to assign to the image_count property of this UpdateContainerScanRecipeDetails.
        :type image_count: int

        :param scan_settings:
            The value to assign to the scan_settings property of this UpdateContainerScanRecipeDetails.
        :type scan_settings: oci.vulnerability_scanning.models.ContainerScanSettings

        :param freeform_tags:
            The value to assign to the freeform_tags property of this UpdateContainerScanRecipeDetails.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this UpdateContainerScanRecipeDetails.
        :type defined_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'display_name': 'str',
            'image_count': 'int',
            'scan_settings': 'ContainerScanSettings',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'display_name': 'displayName',
            'image_count': 'imageCount',
            'scan_settings': 'scanSettings',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags'
        }

        self._display_name = None
        self._image_count = None
        self._scan_settings = None
        self._freeform_tags = None
        self._defined_tags = None

    @property
    def display_name(self):
        """
        Gets the display_name of this UpdateContainerScanRecipeDetails.
        User friendly name of container scan recipe


        :return: The display_name of this UpdateContainerScanRecipeDetails.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this UpdateContainerScanRecipeDetails.
        User friendly name of container scan recipe


        :param display_name: The display_name of this UpdateContainerScanRecipeDetails.
        :type: str
        """
        self._display_name = display_name

    @property
    def image_count(self):
        """
        Gets the image_count of this UpdateContainerScanRecipeDetails.
        This field is set equal to the number of images we want to scan in the first go when the recipe is created


        :return: The image_count of this UpdateContainerScanRecipeDetails.
        :rtype: int
        """
        return self._image_count

    @image_count.setter
    def image_count(self, image_count):
        """
        Sets the image_count of this UpdateContainerScanRecipeDetails.
        This field is set equal to the number of images we want to scan in the first go when the recipe is created


        :param image_count: The image_count of this UpdateContainerScanRecipeDetails.
        :type: int
        """
        self._image_count = image_count

    @property
    def scan_settings(self):
        """
        Gets the scan_settings of this UpdateContainerScanRecipeDetails.

        :return: The scan_settings of this UpdateContainerScanRecipeDetails.
        :rtype: oci.vulnerability_scanning.models.ContainerScanSettings
        """
        return self._scan_settings

    @scan_settings.setter
    def scan_settings(self, scan_settings):
        """
        Sets the scan_settings of this UpdateContainerScanRecipeDetails.

        :param scan_settings: The scan_settings of this UpdateContainerScanRecipeDetails.
        :type: oci.vulnerability_scanning.models.ContainerScanSettings
        """
        self._scan_settings = scan_settings

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this UpdateContainerScanRecipeDetails.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :return: The freeform_tags of this UpdateContainerScanRecipeDetails.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this UpdateContainerScanRecipeDetails.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :param freeform_tags: The freeform_tags of this UpdateContainerScanRecipeDetails.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this UpdateContainerScanRecipeDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :return: The defined_tags of this UpdateContainerScanRecipeDetails.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this UpdateContainerScanRecipeDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :param defined_tags: The defined_tags of this UpdateContainerScanRecipeDetails.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
